#include"scmc.h"
#include<stdlib.h>
#include<stdio.h>
#include<string.h>
#include<math.h>
#define PI 3.14159265

SCMC_MAIN

int16_t gridunit=leftwallflametrap;
int16_t uncenter=siegetankturret_tankmode;

int16_t dc_state=0;
int16_t dc_rand=1;
int16_t dc_grid[2][3]={{2,3,4},{5,6,7}};
int16_t dc_temp[2]={8,9};
int16_t dc_order=10;
int16_t dc_pos[2]={11,12};
int16_t dc_dir=13;
int16_t dc_speed_mag=14;
int16_t dc_speed[2]={15,16};

int8_t hyper=0;
int8_t _rand[6]={1,2,3,4,5,6};
int8_t sgen[3]={7,8,9};

int tile=32;
int dim=128;
int map=tile*128;
int space=tile*16;
int area=tile*96;
int accu=8;
int gran=8;
int angle=128;
int agran=8;
int maxspeed=16;
int adj_y=tile/accu*1;

int16_t _units[7]={devouringone,jimraynor_vulture,fenix_dragoon,edmundduke_tankmode,torrasque,warbringer,darkarchon};

char wavs[7][5][64]={
	{
		"sound\\Zerg\\Zergling\\ZZeWht00.WAV",
		"sound\\Zerg\\Zergling\\ZZeWht01.WAV",
		"sound\\Zerg\\Zergling\\ZZeWht02.WAV",
		"sound\\Zerg\\Zergling\\ZZeWht03.WAV",
		"sound\\Zerg\\Zergling\\ZZePss00.WAV",
	},
	{
		"sound\\Terran\\RAYNORV\\URVWht00.WAV",
		"sound\\Terran\\RAYNORV\\URVWht01.WAV",
		"sound\\Terran\\RAYNORV\\URVWht02.WAV",
		"sound\\Terran\\RAYNORV\\URVWht03.WAV",
		"sound\\Terran\\RAYNORV\\URVPss00.WAV",
	},
	{
		"sound\\Protoss\\FENIXD\\UFdWht00.WAV",
		"sound\\Protoss\\FENIXD\\UFdWht01.WAV",
		"sound\\Protoss\\FENIXD\\UFdWht02.WAV",
		"sound\\Protoss\\FENIXD\\UFdWht03.WAV",
		"sound\\Protoss\\FENIXD\\UFdPss00.WAV",
	},
	{
		"sound\\Terran\\DUKET\\UDTWht00.WAV",
		"sound\\Terran\\DUKET\\UDTWht01.WAV",
		"sound\\Terran\\DUKET\\UDTWht02.WAV",
		"sound\\Terran\\DUKET\\UDTWht03.WAV",
		"sound\\Terran\\DUKET\\UDTPss00.WAV",
	},
	{
		"sound\\Zerg\\Ultra\\ZUlWht00.WAV",
		"sound\\Zerg\\Ultra\\ZUlWht01.WAV",
		"sound\\Zerg\\Ultra\\ZUlWht02.WAV",
		"sound\\Zerg\\Ultra\\ZUlWht03.WAV",
		"sound\\Zerg\\Ultra\\ZUlPss00.WAV",
	},
	{
		"sound\\Protoss\\TRILOBYTE\\PTrWht00.WAV",
		"sound\\Protoss\\TRILOBYTE\\PTrWht01.WAV",
		"sound\\Protoss\\TRILOBYTE\\PTrWht02.WAV",
		"sound\\Protoss\\TRILOBYTE\\PTrWht03.WAV",
		"sound\\Protoss\\TRILOBYTE\\PTrPss00.WAV",
	},
	{
		"sound\\Protoss\\DARCHON\\PDaWht00.WAV",
		"sound\\Protoss\\DARCHON\\PDaWht01.WAV",
	},
};

char desc[7][256]={
	CENTER "Devouring One Speed: Weight:",
	CENTER "Jim Raynor Speed: Weight:",
	CENTER "Fenix Speed: Weight:",
	CENTER "Edmund Duke Speed: Weight:",
	CENTER "Torrasque Speed: Weight:",
	CENTER "Warbringer Speed: Weight:",
	CENTER "Dark Archon Speed: Weight:",
};
void scmc(void){
	*erab=badlands;

	FILE *bmp=fopen("starkart6.bmp","rb");
	fseek(bmp,0,SEEK_END);
	long bmps=ftell(bmp);
	rewind(bmp);
	char *bmpb=(char *)malloc(bmps);
	fread(bmpb,1,bmps,bmp);
	uint32_t bmpdo=*(uint32_t *)(bmpb+10);
	uint16_t (*mb)[dim][dim]=(uint16_t (*)[dim][dim])mtxmb;
	for(int i=0;i<dim;i++){
		for(int j=0;j<dim;j++){
			uint32_t p=*(uint32_t *)(bmpb+bmpdo+dim*3*i+3*j)&0x00FFFFFF;
			if(p==0x000000){
				(*mb)[dim-1-i][j]=16*1;
			}else if(p==0xFF0000){
				(*mb)[dim-1-i][j]=417*16;
			}else if(p==0x00FF00){
				(*mb)[dim-1-i][j]=12*16;
			}else if(p==0x0000FF){
				(*mb)[dim-1-i][j]=0;
			}else if(p==0xFFFFFF){
				(*mb)[dim-1-i][j]=4*16;
			}
		}
	}
	free(bmpb);
	fclose(bmp);

	for(int i=0;i<6;i++){
		thg2(p1,231,tile*(72+i),tile*46,1<<12);
	}
	
	strs=2;
	*strc=0;
	
	for(int i=1;i<1+6;i++){
		trigp(1<<f1);
		deaths(161877,0,exactly,6455960-336*(i-1));
		char s[100];
		sprintf(s,"%d",i);
		displaytextmessagea(str(s));
	}

	sprpb->n=str("StarKart");
	sprpb->d=str("Made by: x86\n"
	             "July 15, 2012\n"
	             "For the 2012 SEN One Week Mapping Contest");

	memset(unixb,0,sizeof(*unixb));
	memset(upgxb,0,sizeof(*upgxb));
	memset(tecxb,0,sizeof(*tecxb));
	memset(pupxb,0,sizeof(*pupxb));
	memset(ptexb,0,sizeof(*ptexb));

	unixb->s[_units[0]]=str(DEFAULT);
	unixb->hp[_units[0]]=256*1+9;
	unixb->s[_units[1]]=str(DEFAULT);
	unixb->hp[_units[1]]=256*1+9;
	unixb->s[_units[2]]=str(DEFAULT);
	unixb->hp[_units[2]]=256*1+9;
	unixb->s[_units[3]]=str(DEFAULT);
	unixb->hp[_units[3]]=256*1+9;
	unixb->s[_units[4]]=str(DEFAULT);
	unixb->hp[_units[4]]=256*1+9;
	unixb->s[_units[5]]=str(DEFAULT);
	unixb->hp[_units[5]]=256*1+9;
	unixb->s[_units[6]]=str(DEFAULT);
	unixb->hp[_units[6]]=256*1+9;
	
	ptexb->a[p1][tech_burrowing]=1;
	ptexb->r[p1][tech_burrowing]=1;

	memset(ownrb,0,sizeof(*ownrb));
	memset(forcb,0,sizeof(*forcb));
	memset(sideb,0,sizeof(*sideb));
	forcb->s[f1-f1]=str("Racers");
	//forcb->f[f1-f1]=forc_allied|forc_random;
	for(int i=0;i<6;i++){
		//(*ownrb)[p2+i]=ownr_human;
		(*ownrb)[p2+i]=ownr_computer;
		forcb->p[p2+i]=f1-f1;
		(*sideb)[p2+i]=side_random;
	}
	for(int i=0;i<2;i++){
		int8_t p[2]={p1,p8};
		(*ownrb)[p[i]]=ownr_computer2;
		forcb->p[p[i]]=f2-f1;
	}

	(*ownrb)[p2]=ownr_human;

	//locs
	memset(mrgnb,0,sizeof(*mrgnb)*mrgnn);
	uint8_t anywhere=mrgn(0,0,map,map,0);
	uint8_t gen[2];
	for(int i=0;i<2;i++){
		gen[i]=mrgn(0,0,0,0,0);
	}
	uint8_t grid_x_static[4];
	for(int i=0;i<4;i++){
		int32_t x=space+accu/2+accu*(area/accu/4*(1+i)-1);
		int32_t y=map-64;
		grid_x_static[i]=mrgn(x,y,x,y,0);
	}
	uint8_t grid_x[4];
	grid_x[0]=mrgn(1,0,0,0,0);
	for(int i=0;i<3;i++){
		grid_x[1+i]=mrgn(0,0,2+(accu*((1<<2*(i+1))-2))*2,0,0);
	}
	uint8_t shift=mrgn(0,0,0,map*2,0);
	uint8_t grid_y[area/accu/2];
	for(int i=0;i<area/accu/2;i++){
		grid_y[i]=mrgn(0,0,0,(space+accu/2+accu*i)*2,0);
	}
	uint8_t topleft=mrgn(0,0,tile,tile,0);
	uint8_t norm=mrgn(space,space,space+area,space+area,0); 
	uint8_t dirt=mrgn(space,space,space+area,space+area,medium);
	uint8_t pos[6];
	for(int i=0;i<6;i++){
		pos[i]=mrgn(0,0,0,0,0);
	}
	
	for(int i=0;i<8;i++){
		unit(p1+i,startlocation,0,0,0,0,0,0,0,0);
	}
	//unit(p2,wraith,map/2,map/2,0,0,0,0,0,invincible);
	for(int i=0;i<1+(2*7);i++){
		unit(p1,zergling,map/2,map/2,0,0,0,0,0,burrowed);
	}
	//map revealers
	for(int i=0;i<7;i++){
		int j=1+6;
		int k=7*32;
		for(int l=1;l<j;l++){
			for(int m=1;m<j;m++){
				unit(p1+i,maprevealer,k+(map-k*2)/j*l,k+(map-k*2)/j*m,0,0,0,0,0,0);
			}
		}
	}

	//start
	trig(1<<p1);
	removeunit(f1,maprevealer);
	for(int i=0;i<6;i++){
		giveunitstoplayer(current,zergling,p7-i,1,anywhere);
	}
	removeunit(current,zergling);

	//always
	trigp(1<<pall);
	for(int i=0;i<6;i++){
		char s[5];
		sprintf(s,"-Vi%d",p2+i);
		//runaiscript(*(int32_t *)s);
	}
	modifyenergy(current,any,all,anywhere,0);
	setdeaths(current,dc_rand,setto,0);
	for(int i=0;i<6;i++){
		setswitch(_rand[i],_random);
	}
	setdeaths(current,dc_grid[0][0],setto,0);
	setdeaths(current,dc_grid[1][0],setto,0);
	setdeaths(current,dc_grid[0][1],setto,0);
	setdeaths(current,dc_grid[1][1],setto,adj_y);
	for(int i=0;i<6;i++){
		trigp(1<<pall);
		_switch(_rand[i],isset);
		setdeaths(current,dc_rand,add,1<<i);
	}

	//init
	trigp(1<<p1);
	deaths(current,dc_state,exactly,0);
	for(int i=0;i<6;i++){
		removeunit(p7-i,any);
	}
	trigp(1<<f1);
	deaths(current,dc_state,exactly,0);
	muteunitspeech();
	leaderboardcomputerplayers(toclear);
	runaiscript(*(int32_t *)"+Vi0");
	//starting pos
	for(int i=0;i<6;i++){
		int32_t x=tile*73+(tile*3)*(i%2);
		int32_t y=tile*44-(tile*2)*i;
		uint8_t m=mrgn(x,y,x,y,0);
		trigp(1<<f1);
		deaths(current,dc_state,exactly,1);
		deaths(p1,dc_order,exactly,i);
		movelocation(p1,uncenter,m,gen[0]);
		setdeaths(current,dc_pos[0],setto,gran*(-space+x));
		setdeaths(current,dc_pos[1],setto,gran*(-space+y));
	}
	//create unit
	for(int i=0;i<7;i++){
		for(int j=0;j<5;j++){
			if(5*i+j>=32)break;
			trigp(1<<f1);
			deaths(current,dc_state,exactly,1);
			deaths(current,dc_rand,atleast,2*(5*i+j));
			deaths(current,dc_rand,atmost,2*(5*i+j+1)-1);
			createunitwithproperties(current,_units[i],1,gen[0],uprpp(100,0,0,0,10,invincible));
			displaytextmessagea(str(desc[i]));
			transmission(_units[i],gen[0],str(wavs[i][j]),setto,2000,0);
		}
	}
	for(int i=0;i<6;i++){
		trigp(1<<(p2+i));
		deaths(current,dc_state,exactly,1);
		movelocation(p1,uncenter,gen[0],pos[i]);
		setdeaths(p1,dc_order,add,1);
		//setdeaths(current,dc_dir,setto,agran*(angle*3/4));
		setdeaths(current,dc_speed_mag,setto,3);
		setdeaths(current,dc_speed[0],setto,0);
		setdeaths(current,dc_speed[1],setto,8);
	}
	
	trigp(1<<pall);
	deaths(current,dc_state,atmost,2-1);
	setdeaths(current,dc_state,add,1);

	trigp(1<<f1);
	deaths(current,dc_state,exactly,2);
	setdeaths(current,dc_speed_mag,subtract,1);
	
	for(int i=0;i<2;i++){
		//transfer unit pos to grid unit/screen pos
		for(int j=0;j<10/2;j++){
			int k=10+2*(-1-j);
			int l=(3+3)+10+2*(-1-j);
			trigp(1<<p1|1<<p2|1<<p3|1<<p4|1<<p5|1<<p6|1<<p7|1<<p8|1<<pall|1<<f1|1<<f2);
			deaths(current,dc_state,exactly,2);
			deaths(current,dc_pos[i],atleast,1<<l);
			setdeaths(current,dc_pos[i],subtract,1<<l);
			setdeaths(current,dc_grid[i][0],add,1<<k);
			setdeaths(current,dc_grid[i][1],add,1<<k);
			setdeaths(current,dc_temp[0],add,1<<k);
		}
		//restore unit pos
		for(int j=0;j<10/2;j++){
			int k=10+2*(-1-j);
			int l=(3+3)+10+2*(-1-j);
			trigp(1<<p1|1<<p2|1<<p3|1<<p4|1<<p5|1<<p6|1<<p7|1<<p8|1<<pall|1<<f1|1<<f2);
			deaths(current,dc_state,exactly,2);
			deaths(current,dc_temp[0],atleast,1<<k);
			setdeaths(current,dc_temp[0],subtract,1<<k);
			setdeaths(current,dc_pos[i],add,1<<l);
		}
	}
	//adjust screen pos dom
	int32_t a[2]={tile/accu*9,tile/accu*4};
	trigp(1<<f1);
	deaths(current,dc_state,exactly,2);
	deaths(current,dc_dir,atmost,agran*(angle*1/8));
	setdeaths(current,dc_grid[0][1],add,a[0]);
	trigp(1<<f1);
	deaths(current,dc_state,exactly,2);
	deaths(current,dc_dir,atleast,agran*(angle*1/8));
	deaths(current,dc_dir,atmost,agran*(angle*3/8));
	setdeaths(current,dc_grid[1][1],subtract,a[1]);
	setswitch(sgen[0],toset);
	trigp(1<<f1);
	deaths(current,dc_state,exactly,2);
	deaths(current,dc_dir,atleast,agran*(angle*3/8));
	deaths(current,dc_dir,atmost,agran*(angle*5/8));
	setdeaths(current,dc_grid[0][1],subtract,a[0]);
	trigp(1<<f1);
	deaths(current,dc_state,exactly,2);
	deaths(current,dc_dir,atleast,agran*(angle*5/8));
	deaths(current,dc_dir,atmost,agran*(angle*7/8));
	setdeaths(current,dc_grid[1][1],add,a[1]);
	setswitch(sgen[0],toset);
	trigp(1<<f1);
	deaths(current,dc_state,exactly,2);
	deaths(current,dc_dir,atleast,agran*(angle*7/8));
	setdeaths(current,dc_grid[0][1],add,a[0]);
	//adjust screen pos rec
	//shift 180
	trigp(1<<f1);
	deaths(current,dc_state,exactly,2);
	deaths(current,dc_dir,atleast,agran*(angle*4/8));
	setdeaths(current,dc_dir,subtract,agran*(angle*4/8));
	setswitch(sgen[1],toset);
	//shift 90
	trigp(1<<f1);
	deaths(current,dc_state,exactly,2);
	deaths(current,dc_dir,atleast,agran*(angle*2/8));
	setdeaths(current,dc_dir,subtract,agran*(angle*2/8));
	setdeaths(current,dc_temp[0],setto,agran*(angle*2/8)-1);
	setswitch(sgen[2],toset);
	//set dc_temp[0] to adjusted value
	for(int i=0;i<8/2;i++){
		int j=8+2*(-1-i);
		trigp(1<<p1|1<<p2|1<<p3|1<<p4|1<<p5|1<<p6|1<<p7|1<<p8|1<<pall|1<<f1|1<<f2);
		deaths(current,dc_state,exactly,2);
		_switch(sgen[2],isset);
		deaths(current,dc_dir,atleast,1<<j);
		setdeaths(current,dc_dir,subtract,1<<j);
		setdeaths(current,dc_temp[0],subtract,1<<j);
		setdeaths(current,dc_temp[1],add,1<<j);
	}
	//transfer dc_temp[0] to dc_dir
	for(int i=0;i<6/2;i++){
		int j=3+6+2*(-1-i);
		trigp(1<<p1|1<<p2|1<<p3|1<<p4|1<<p5|1<<p6|1<<p7|1<<p8|1<<pall|1<<f1|1<<f2);
		deaths(current,dc_state,exactly,2);
		_switch(sgen[2],isset);
		deaths(current,dc_temp[0],atleast,1<<j);
		setdeaths(current,dc_temp[0],subtract,1<<j);
		setdeaths(current,dc_dir,add,1<<j);
	}
	//set dc_temp[0] to rec displacement
	for(int i=1;i<angle/8;i++){
		trigp(1<<f1);
		deaths(current,dc_state,exactly,2);
		deaths(current,dc_dir,atleast,agran*i);
		deaths(current,dc_dir,atmost,agran*(i+1)-1);
		setdeaths(current,dc_temp[0],setto,(int32_t)floor(a[1]*tan(2*PI*i/angle)+0.5));
	}
	for(int i=angle/8+1;i<angle/4;i++){
		trigp(1<<f1);
		deaths(current,dc_state,exactly,2);
		deaths(current,dc_dir,atleast,agran*i);
		deaths(current,dc_dir,atmost,agran*(i+1)-1);
		setdeaths(current,dc_temp[0],setto,(int32_t)floor(a[0]*(1/tan(2*PI*i/angle))+0.5));
	}
	//adjust grid screen pos rec
	for(int i=0;i<6/2;i++){
		int j=6+2*(-1-i);
		trigp(1<<p1|1<<p2|1<<p3|1<<p4|1<<p5|1<<p6|1<<p7|1<<p8|1<<pall|1<<f1|1<<f2);
		deaths(current,dc_state,exactly,2);
		_switch(sgen[0],isset);
		_switch(sgen[1],isclear);
		deaths(current,dc_temp[0],atleast,1<<j);
		setdeaths(current,dc_temp[0],subtract,1<<j);
		setdeaths(current,dc_grid[0][1],add,1<<j);
	}
	for(int i=0;i<6/2;i++){
		int j=6+2*(-1-i);
		trigp(1<<p1|1<<p2|1<<p3|1<<p4|1<<p5|1<<p6|1<<p7|1<<p8|1<<pall|1<<f1|1<<f2);
		deaths(current,dc_state,exactly,2);
		_switch(sgen[0],isclear);
		_switch(sgen[1],isclear);
		deaths(current,dc_temp[0],atleast,1<<j);
		setdeaths(current,dc_temp[0],subtract,1<<j);
		setdeaths(current,dc_grid[1][1],subtract,1<<j);
	}
	for(int i=0;i<6/2;i++){
		int j=6+2*(-1-i);
		trigp(1<<p1|1<<p2|1<<p3|1<<p4|1<<p5|1<<p6|1<<p7|1<<p8|1<<pall|1<<f1|1<<f2);
		deaths(current,dc_state,exactly,2);
		_switch(sgen[0],isset);
		_switch(sgen[1],isset);
		deaths(current,dc_temp[0],atleast,1<<j);
		setdeaths(current,dc_temp[0],subtract,1<<j);
		setdeaths(current,dc_grid[0][1],subtract,1<<j);
	}
	for(int i=0;i<6/2;i++){
		int j=6+2*(-1-i);
		trigp(1<<p1|1<<p2|1<<p3|1<<p4|1<<p5|1<<p6|1<<p7|1<<p8|1<<pall|1<<f1|1<<f2);
		deaths(current,dc_state,exactly,2);
		_switch(sgen[0],isclear);
		_switch(sgen[1],isset);
		deaths(current,dc_temp[0],atleast,1<<j);
		setdeaths(current,dc_temp[0],subtract,1<<j);
		setdeaths(current,dc_grid[1][1],add,1<<j);
	}
	//reshift 90
	trigp(1<<f1);
	deaths(current,dc_state,exactly,2);
	_switch(sgen[2],isset);
	setdeaths(current,dc_dir,setto,agran*(angle*2/8));
	for(int i=0;i<8/2;i++){
		int j=8+2*(-1-i);
		trigp(1<<f1);
		deaths(current,dc_state,exactly,2);
		_switch(sgen[2],isset);
		deaths(current,dc_temp[1],atleast,1<<j);
		setdeaths(current,dc_temp[1],subtract,1<<j);
		setdeaths(current,dc_dir,add,1<<j);
	}
	//reshift 180
	trigp(1<<f1);
	deaths(current,dc_state,exactly,2);
	_switch(sgen[1],isset);
	setdeaths(current,dc_dir,add,agran*(angle*4/8));
	
	trigp(1<<f1);
	setswitch(sgen[0],toclear);
	setswitch(sgen[1],toclear);
	setswitch(sgen[2],toclear);
	
	//location grid units
	for(int i=0;i<area/accu;i++){
		unit(p9,gridunit,space+accu/2+accu*i,map-64,0,0,0,0,0,0);
	}
	//location grid
	for(int i=0;i<3;i++){
		int r=i==2?1:0;
		//location grid x
		for(int j=0;j<4;j++){
			trigp(1<<pall);
			if(j>0){
				deaths(current,dc_grid[0][i],atleast,area/accu/4*j);
			}
			if(j<4-1){
				deaths(current,dc_grid[0][i],atmost,area/accu/4*(j+1)-1);
			}
			if(j>0){
				setdeaths(current,dc_grid[0][i],subtract,area/accu/4*j);
				if(r){
					setdeaths(current,dc_temp[1],add,area/accu/4*j);
				}
			}
			movelocation(p1,uncenter,grid_x_static[j],gen[0]);
			setdeaths(current,dc_temp[0],setto,area/accu/4-1);
		}
		for(int j=0;j<8/2;j++){
			int k=8+2*(-1-j);
			trigp(1<<p1|1<<p2|1<<p3|1<<p4|1<<p5|1<<p6|1<<p7|1<<p8|1<<pall|1<<f1|1<<f2);
			deaths(current,dc_grid[0][i],atleast,1<<k);
			setdeaths(current,dc_grid[0][i],subtract,1<<k);
			setdeaths(current,dc_temp[0],subtract,1<<k);
			if(r){
				setdeaths(current,dc_temp[1],add,1<<k);
			}
		}
		for(int j=0;j<8/2;j++){
			int k=8+2*(-1-j);
			trigp(1<<p1|1<<p2|1<<p3|1<<p4|1<<p5|1<<p6|1<<p7|1<<p8|1<<pall|1<<f1|1<<f2);
			deaths(current,dc_temp[0],atleast,1<<k);
			setdeaths(current,dc_temp[0],subtract,1<<k);
			movelocation(p1,uncenter,gen[0],grid_x[3-j]);
			movelocation(p9,gridunit,grid_x[3-j],gen[0]);
		}
		if(r){
			for(int j=0;j<10/2;j++){
				int k=10+2*(-1-j);
				trigp(1<<p1|1<<p2|1<<p3|1<<p4|1<<p5|1<<p6|1<<p7|1<<p8|1<<pall|1<<f1|1<<f2);
				deaths(current,dc_temp[1],atleast,1<<k);
				setdeaths(current,dc_temp[1],subtract,1<<k);
				setdeaths(current,dc_grid[0][i],add,1<<k);
			}
		}
		//location grid y handle shift
		trigp(1<<pall);
		deaths(current,dc_grid[1][i],atmost,area/accu/2-1);
		movelocation(p1,uncenter,gen[0],shift);
		movelocation(p1,uncenter,shift,gen[0]);
		setdeaths(current,dc_temp[0],setto,area/accu-1);
		setswitch(sgen[0],toset);
		for(int j=0;j<8/2;j++){
			int k=8+2*(-1-j);
			trigp(1<<p1|1<<p2|1<<p3|1<<p4|1<<p5|1<<p6|1<<p7|1<<p8|1<<pall|1<<f1|1<<f2);
			_switch(sgen[0],isset);
			deaths(current,dc_grid[1][i],atleast,1<<k);
			setdeaths(current,dc_grid[1][i],subtract,1<<k);
			setdeaths(current,dc_temp[0],subtract,1<<k);
			if(r){
				setdeaths(current,dc_temp[1],add,1<<k);
			}
		}
		for(int j=0;j<10/2;j++){
			int k=10-2*(1+j);
			trigp(1<<p1|1<<p2|1<<p3|1<<p4|1<<p5|1<<p6|1<<p7|1<<p8|1<<pall|1<<f1|1<<f2);
			deaths(current,dc_temp[0],atleast,1<<k);
			setdeaths(current,dc_temp[0],subtract,1<<k);
			setdeaths(current,dc_grid[1][i],add,1<<k);
		}
		//location grid y
		for(int j=0;j<area/accu/2;j++){
			trigp(1<<pall);
			deaths(current,dc_grid[1][i],exactly,area/accu/2+j);
			movelocation(p1,uncenter,gen[0],grid_y[area/accu/2-(1+j)]);
			movelocation(p1,uncenter,grid_y[area/accu/2-(1+j)],gen[0]);
		}
		if(r){
			trigp(1<<pall);
			_switch(sgen[0],isset);
			setswitch(sgen[0],toclear);
			setdeaths(current,dc_grid[1][i],setto,0);
			for(int j=0;j<8/2;j++){
				int k=8+2*(-1-j);
				trigp(1<<p1|1<<p2|1<<p3|1<<p4|1<<p5|1<<p6|1<<p7|1<<p8|1<<pall|1<<f1|1<<f2);
				deaths(current,dc_temp[1],atleast,1<<k);
				setdeaths(current,dc_temp[1],subtract,1<<k);
				setdeaths(current,dc_grid[1][i],add,1<<k);
			}
		}
		
		if(i==0){
			//trigp(1<<f1);
			//deaths(current,dc_state,exactly,2);
			//order(current,any,norm,gen[0],patrol);
		}else if(i==1){
			trigp(1<<f1);
			moveunit(current,wraith,1,anywhere,gen[0]);
			centerview(gen[0]);
		}else if(i==2){
			//trigp(1<<p2);
			//moveunit(current,wraith,1,anywhere,gen[0]);
			//centerview(gen[0]);
		}
	}

	//hypers
	trigp(1<<p1);
	_switch(hyper,isset);
	wait(0);
	setswitch(hyper,toclear);
	trigp(1<<p8);
	wait(0);
	setswitch(hyper,toset);
	wait(0);
}